# bar_builder.rb

module FTLTools

  class BarBuilder
 
    YEAR_OFFSET = 584
    GRADE       = [ "dive", "joint", "local", "pub", "club", "posh establishment" ]
    SIZE        = [ "very small", "small", "small", "medium", "large" ].sample

    attr_reader :bar

    def initialize
      @bar    = FTLTools::Bar.new
      @dice   = FTLTools::Dice.new
    end

    def reset
      @bar    = FTLTools::Bar.new
    end

    def setup(data = {})
      @data             = data
      @bar.name         = @data.fetch(:name, generate_name) 
      @bar.size         = @data.fetch(:size, generate_size)
      @bar.grade        = @data.fetch(:grade, generate_grade)
      @bar.patrons      = build_patrons
      #@bar.time         = generate_time
      return @bar
    end

    def generate_grade
      GRADE.sample
    end

    def generate_name
      [ "Lusty's Dive", "Joe's Bar and Blowfish Emporium", "Beers and Dears" ].sample
    end
    
    def generate_size
      SIZE.sample
    end 

    #def generate_time
    #  t = Time.now
    #  year  = t.year - YEAR_OFFSET
    #  day   = t.strftime("%j")
    #  time = [year, day].join('.')
    #end
 
    def build_patrons
      builder     = FTLTools::CharacterBuilder.new
      patrons     = Array.new
      max         = rand(6) + 1
      if ['medium', 'large'].include?(@bar.size)
        max = (max + 2) * 3 
      end
      max.times {
        patrons   << builder.setup
        builder.reset
      }
      patrons
    end

  end
end
