# text_adapter.rb

module FTLTools
  module Adapters
    class Text
      def start( file )
        @file = file
        @data   = Array.new
        File.readlines(@file).each { |line|
          line.strip!
          next if line.start_with?('#') or line.length < 2
          @data << line
        }
        @data
      end

      def items_from_options(num = 1, unique = true)
        items = Array.new
        num.times {
          item     = @data.sample.strip
          items << item
          @data.delete(item) if unique
          break if @data.count == 0
        }
        items
      end

      def item
        items_from_options[0]
      end
       
      def array_from_data
        @data
      end

      def hash_from_data
        data_hash = Hash.new
        @data.each { |line|
          line_array      = line.split
          next if line_array.count < 2
          key             = line_array.shift
          value           = line_array.join(' ')
          data_hash[key]  = value
        }
        data_hash
      end

    end
  end
end
